uniform mat4 uMVPMatrix;
attribute vec4 aPosition;
attribute vec2 aTextureCoord;
varying vec2 vTextureCoord;



uniform mat4 uMMatrix; //任
uniform vec3 uLightLocation;//Դλ
uniform vec3 uCamera;	//λ

attribute vec3 aNormal;    //
varying vec3 vPosition;//ڴݸƬԪɫĶλ
varying vec4 vAmbient;//ڴݸƬԪɫĻ
varying vec4 vDiffuse;//ڴݸƬԪɫɢ
varying vec4 vSpecular;//ڴݸƬԪɫľ淴


//λռķ
void pointLight(					//λռķ
  in vec3 normal,				//
  inout vec4 ambient,			//ǿ
  inout vec4 diffuse,				//ɢǿ
  inout vec4 specular,			//ǿ
  in vec3 lightLocation,			//Դλ
  in vec4 lightAmbient,			//ǿ
  in vec4 lightDiffuse,			//ɢǿ
  in vec4 lightSpecular			//ǿ
){
  ambient=lightAmbient;			//ֱӵóǿ  
  vec3 normalTarget=vec3(aPosition)+normal;	//任ķ
  vec3 newNormal=(uMMatrix*vec4(normalTarget,1)).xyz-(uMMatrix*aPosition).xyz;
  newNormal=normalize(newNormal); 	//Է
  //ӱ㵽
  vec3 eye= normalize(uCamera-(uMMatrix*aPosition).xyz);  
  //ӱ㵽Դλõvp
  vec3 vp= normalize(lightLocation-(uMMatrix*aPosition).xyz);  
  vp=normalize(vp);//ʽvp
  vec3 halfVector=normalize(vp+eye);	//ߵİ    
  float shininess=50.0;				//ֲڶȣԽСԽ⻬
  float nDotViewPosition=max(0.0,dot(newNormal,vp)); 	//vpĵ0ֵ
  diffuse=lightDiffuse*nDotViewPosition;				//ɢǿ
  float nDotViewHalfVector=dot(newNormal,halfVector);	//ĵ 
  float powerFactor=max(0.0,pow(nDotViewHalfVector,shininess)); 	//淴ǿ
  specular=lightSpecular*powerFactor;    			//㾵ǿ
}



void main() {
gl_Position = uMVPMatrix * aPosition;
vTextureCoord = aTextureCoord;


 vec4 ambientTemp=vec4(0.0,0.0,0.0,0.0);
   vec4 diffuseTemp=vec4(0.0,0.0,0.0,0.0);
   vec4 specularTemp=vec4(0.0,0.0,0.0,0.0);   
   
   pointLight(normalize(aNormal),ambientTemp,diffuseTemp,specularTemp,uLightLocation,vec4(0.0,0.0,0.0,1.0),vec4(1.0,1.0,1.0,1.0),vec4(0.0,0.0,0.0,1.0));
   
   vAmbient=ambientTemp;
   vDiffuse=diffuseTemp;
   vSpecular=specularTemp;
 



}